<template>
    <div class="users">
        <h1>User Domains</h1>
        <div>
            <h3>add these nameservers to your domains</h3>
            <ul v-if="error" class="alert-primary ">
                <li v-for="ns  in $auth.user().nameservers">
                    {{ns}}
                </li>
            </ul>
        </div>
        <div class="loading" v-if="loading">
            <span>Loading...</span>
        </div>

        <ul v-if="success" class="alert-success success">
            <li>{{success}}</li>
        </ul>
        <ul v-if="error" class="alert-danger error">
            <li v-for="err  in error">
                {{err}}
            </li>
        </ul>

        <ul v-if="domains">
            <li v-for="domain  in domains">
                <strong>Domain:</strong> {{ domain.domain }} ----
                <span>  {{ domain.verified ? 'verified' : 'pending'}}</span>,
                <button :disabled="fetching" v-if="! domain.verified" @click="verify(domain)" class="btn btn-primary" >verify Now</button>
                <button :disabled="fetching"  @click="deleteDomain(domain)" class="btn btn-danger" >delete</button>
            </li>
        </ul>

        <hr>

        <form autocomplete="off" @submit.prevent="storeDomain" method="post">
            <div class="form-group">
                <label for="domain">Domain name</label>
                <input type="text" id="domain" class="form-control" placeholder="example.com" v-model="domain" required>
            </div>
            <button type="submit" class="btn btn-dark">save</button>
        </form>

    </div>
</template>
<script>
    import axios from 'axios';

    export default {
        data() {
            return {
                loading: false,
                domains: [],
                error: [],
                success: null,
                domain: '',
                fetching : false
            };
        },
        created() {
            this.fetchData();
        },
        methods: {
            alertSuccess(msg){
                let vm = this
                this.success = msg
                setTimeout(function () {
                    vm.success = null
                },5000)
            },
            deleteDomain(domain){
                if(confirm('are you sure ?')){
                    let url = `/users/domains/${domain.id}`
                    let vm = this
                    this.error = []
                    vm.fetching = true
                    axios.delete(url,{
                    }).then(function (response) {
                        vm.alertSuccess('Domain deleted Successfully');
                        vm.fetching = false
                        vm.domains.forEach(function (item, index) {
                            if(item.domain === domain.domain){
                                item.verified = true
                                vm.$delete(vm.domains,index);
                            }
                        })
                    }).catch(function (error) {
                        vm.fetching = false
                        if (error.response.status === 400) {
                            vm.error.push(error.response.data.errors)

                        } else {
                            throw error
                        }
                    });
                }
            },
            verify(domain){
                let url = `/users/domains/${domain.id}/verification`
                let vm = this
                this.error = []
                vm.fetching = true
                 axios.post(url, {
                }).then(function (response) {
                     vm.alertSuccess('Gratz ! Domain successfully verified');
                     vm.fetching = false

                     vm.domains.forEach(function (item, index) {
                         if(item.domain === domain.domain){
                             item.verified = true
                         }
                     })
                }).catch(function (error) {
                     vm.fetching = false
                     vm.error.push(error.response.data.message)

                     if (error.response.status === 400) {
                        vm.error.push(error.response.data.errors)

                    } else if (error.response.status === 422) {
                        let nameServers = error.response.data.data.currentNameServers;
                        let err = `name servers are invalid , the current nameservers are ${nameServers.toString()}`
                        vm.error.push(err)
                    }
                });
            },
            fetchData() {
                this.error = [];
                this.users = null;
                this.loading = true;
                axios
                    .get('/users/domains')
                    .then(response => {
                        this.loading = false;
                        this.domains = response.data.data;
                    });
            },
            storeDomain() {
                this.error = [];
                let vm = this;
                return axios.post('/users/domains', {
                    domain: this.domain
                }).then(function (response) {
                    vm.domains.push(response.data.data)
                    vm.domain = null
                }).catch(function (error) {
                    let $errors = error.response.data.errors;

                    if (error.response.status === 400) {
                        vm.error.push(error.response.data.errors)

                    } else if (error.response.status === 422) {
                        _.forOwn($errors, function (value, key) {
                            value.forEach(function (item, key) {
                                vm.error.push(item)
                            });
                        });
                    }
                });
            }
        }
    }
</script>
